<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "idp_provision_multiple_verb".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "IdpProvisionMultipleVerb".
 *
 * Columns in table "idp_provision_multiple_verb" available as properties of the model,
 * followed by relations of table "idp_provision_multiple_verb" available as properties of the model.
 *
 * @property integer $id
 * @property integer $idp_provision_verb_id
 * @property integer $replaced_idp_provision_verb_id
 * @property integer $sort_order
 * @property string $enrich_query
 * @property integer $active
 * @property string $mapping
 * @property string $date_added
 * @property string $date_updated
 *
 * @property IdpProvisionVerb $idpProvisionVerb
 * @property IdpProvisionVerb $replacedIdpProvisionVerb
 */
abstract class BaseIdpProvisionMultipleVerb extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'idp_provision_multiple_verb';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'IdpProvisionMultipleVerb|IdpProvisionMultipleVerbs', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('idp_provision_verb_id, replaced_idp_provision_verb_id, sort_order, date_added, date_updated', 'required'),
            array('idp_provision_verb_id, replaced_idp_provision_verb_id, sort_order, active', 'numerical', 'integerOnly'=>true),
            array('enrich_query, mapping', 'safe'),
            array('enrich_query, active, mapping', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, idp_provision_verb_id, replaced_idp_provision_verb_id, sort_order, enrich_query, active, mapping, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'idpProvisionVerb' => array(self::BELONGS_TO, 'IdpProvisionVerb', 'idp_provision_verb_id'),
            'replacedIdpProvisionVerb' => array(self::BELONGS_TO, 'IdpProvisionVerb', 'replaced_idp_provision_verb_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'idp_provision_verb_id' => null,
            'replaced_idp_provision_verb_id' => null,
            'sort_order' => Yii::t('app', 'Sort Order'),
            'enrich_query' => Yii::t('app', 'Enrich Query'),
            'active' => Yii::t('app', 'Active'),
            'mapping' => Yii::t('app', 'Mapping'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'idpProvisionVerb' => null,
            'replacedIdpProvisionVerb' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('idp_provision_verb_id', $this->idp_provision_verb_id);
        $criteria->compare('replaced_idp_provision_verb_id', $this->replaced_idp_provision_verb_id);
        $criteria->compare('sort_order', $this->sort_order);
        $criteria->compare('enrich_query', $this->enrich_query, true);
        $criteria->compare('active', $this->active);
        $criteria->compare('mapping', $this->mapping, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
